Create an API key

  • POST also PUT /_security/api_key
Auth

Create an API key for access without requiring basic authentication.

Important

If the credential that is used to authenticate this request is an API key, the derived API key cannot have any privileges. If you specify privileges, the API returns an error.

A successful request returns a JSON structure that contains the API key, its unique id, and its name. If applicable, it also returns expiration information for the API key in milliseconds.

Note

By default, API keys never expire. You can specify expiration information when you create the API keys.

The API keys are created by the Elasticsearch API key service, which is automatically enabled. To configure or turn off the API key service, refer to API key service setting documentation.

Read the reference documentation

Required privileges

Cluster privileges manage_own_api_key

Query parameters

refresh enum

If true (the default) then refresh the affected shards to make this operation visible to search, if wait_for then wait for a refresh to make this operation visible to search, if false then do nothing with refreshes.

Values: true false wait_for

Request body

expiration union oneOf

The expiration time for the API key. By default, API keys never expire.

Values: -1 0
name string

A name for the API key.

role_descriptors map string to object

An array of role descriptors for this API key. When it is not specified or it is an empty array, the API key will have a point in time snapshot of permissions of the authenticated user. If you supply role descriptors, the resultant permissions are an intersection of API keys permissions and the authenticated user's permissions thereby limiting the access scope for API keys. The structure of role descriptor is the same as the request for the create role API. For more details, refer to the create or update roles API.

Note

Due to the way in which this permission intersection is calculated, it is not possible to create an API key that is a child of another API key, unless the derived key is created without any privileges. In this case, you must explicitly specify a role descriptor with no privileges. The derived API key can be used for authentication; it will not have authority to call Elasticsearch APIs.

metadata object

Arbitrary metadata that you want to associate with the API key. It supports nested data structure. Within the metadata object, keys beginning with _ are reserved for system usage.

Response

application/json
api_key string required

Generated API key.

expiration number

Expiration in milliseconds for the API key.

id string required

Unique ID for this API key.

name string required

Specifies the name for this API key.

encoded string required

API key credentials which is the base64-encoding of the UTF-8 representation of id and api_key joined by a colon (:).